//---------------------------------------------------------------------------

#include <windows.h>
#include <dsound.h>
#pragma hdrstop

#include "DSound_ERR.h"

#define SIZE(array) (sizeof(array)/sizeof(array[0]))
//---------------------------------------------------------------------------

#pragma package(smart_init)




struct ERR{
HRESULT hr;
char *caption;
char *text;
};

ERR serr[]={
{DS_OK ,"DS_OK ","The request completed successfully. "},
{DSERR_ACCESSDENIED ,"DSERR_ACCESSDENIED ","The request failed because access was denied. "},
{DSERR_ALLOCATED ,"DSERR_ALLOCATED ","The request failed because resources, such as a priority level, were already in use by another caller. "},
{DSERR_ALREADYINITIALIZED ,"DSERR_ALREADYINITIALIZED ","The object is already initialized. "},
{DSERR_BADFORMAT ,"DSERR_BADFORMAT ","The specified wave format is not supported. "},
{DSERR_BUFFERLOST ,"DSERR_BUFFERLOST ","The buffer memory has been lost and must be restored. "},
{DSERR_CONTROLUNAVAIL ,"DSERR_CONTROLUNAVAIL ","The buffer control (volume, pan, and so on) requested by the caller is not available. "},
{DSERR_GENERIC ,"DSERR_GENERIC ","An undetermined error occurred inside the DirectSound subsystem. "},
//{DSERR_HWUNAVAIL ,"DSERR_HWUNAVAIL ","The DirectSound hardware device is unavailable. "},
{DSERR_INVALIDCALL ,"DSERR_INVALIDCALL ","This function is not valid for the current state of this object. "},
{DSERR_INVALIDPARAM ,"DSERR_INVALIDPARAM ","An invalid parameter was passed to the returning function. "},
{DSERR_NOAGGREGATION ,"DSERR_NOAGGREGATION ","The object does not support aggregation. "},
{DSERR_NODRIVER ,"DSERR_NODRIVER ","No sound driver is available for use. "},
{DSERR_NOINTERFACE ,"DSERR_NOINTERFACE ","The requested COM interface is not available. "},
{DSERR_OTHERAPPHASPRIO ,"DSERR_OTHERAPPHASPRIO ","Another application has a higher priority level, preventing this call from succeeding "},
{DSERR_OUTOFMEMORY ,"DSERR_OUTOFMEMORY ","The DirectSound subsystem could not allocate sufficient memory to complete the caller's request. "},
{DSERR_PRIOLEVELNEEDED ,"DSERR_PRIOLEVELNEEDED ","The caller does not have the priority level required for the function to succeed. "},
{DSERR_UNINITIALIZED ,"DSERR_UNINITIALIZED ","The IDirectSound::Initialize method has not been called or has not been called successfully before other methods were called. "},
{DSERR_UNSUPPORTED ,"DSERR_UNSUPPORTED ","The function called is not supported at this time."},
};


HRESULT DS_ERR(HRESULT hr)
{
char *text="Unknown ERROR";
char *caption=text;

for(unsigned i=0;i<SIZE(serr);i++)
  if(serr[i].hr==hr)
    {
    text=serr[i].text;
    caption=serr[i].caption;
    break;
    }

MessageBox(NULL,text,caption, MB_OK);

return hr;
}

