//---------------------------------------------------------------------------

#include <windows.h>
#define DIRECTSOUND_VERSION 0x0400
#include <dsound.h>
#include <math.h>
#pragma hdrstop

#include "IDirectSound.h"
#include "DirectSound.h"

#include "DSound_ERR.h"

//---------------------------------------------------------------------------
bool CreateICDirectSound(ICDIRECTSOUND **myclass)
{
C_DIRECTSOUND *l=new C_DIRECTSOUND;

if(l==NULL)
  return true;

*myclass=l;

return true;
}
//---------------------------------------------------------------------------
C_DIRECTSOUND::C_DIRECTSOUND(void)
{
Clear();
}
//---------------------------------------------------------------------------
void C_DIRECTSOUND::Clear(void)
{
pds=NULL;
prim=NULL;
sec=NULL;
evento[0]=NULL;
evento[1]=NULL;
hthread=NULL;
szinbufer=0;

valuecount=DEF_VALUECOUNT;
samplepersec=DEF_SAMPLEPERSEC;
fric=DEF_FRIC;
amp=DEF_AMP;

interogate=false;

wastry=false;
initok=false;
}
//---------------------------------------------------------------------------
bool C_DIRECTSOUND::SelfDestroy(void)
{
if(wastry)
  {
  if( !Uninit() )
    return false;
  }
delete this;

return true;
}
//---------------------------------------------------------------------------
DWORD WINAPI C_DIRECTSOUND::ThreadFunc(void *P)
{
C_DIRECTSOUND *cls=(C_DIRECTSOUND*)P;
return cls->RunInterogate();
}
//---------------------------------------------------------------------------
DWORD   C_DIRECTSOUND::RunInterogate(void)
{

DWORD  n1,n2;
LPVOID p1,p2;

while(run)
{

DWORD WaitResult;

WaitResult=WaitForMultipleObjects(2,evento, FALSE,INFINITE);
if(!run)
  break;

if(WaitResult==WAIT_OBJECT_0+1)//++eventi[0] occurs  busy|free
  {
  if( DS_OK==sec->Lock(szinbufer/2,0,&p1,&n1,&p2,&n2,DSBLOCK_ENTIREBUFFER) )
    {
    //++  OnIn
    Interogate16s(p2,n2);
    sec->Unlock(p1,0,p2,n2);
    }
  continue;
  }

if(WaitResult==WAIT_OBJECT_0+0)//++eventi[1] occurs free|busy
  {
  if( DS_OK==sec->Lock(szinbufer/2,0,&p1,&n1,&p2,&n2,DSBLOCK_ENTIREBUFFER) )
    {
    //++  OnIn
    Interogate16s(p1,n1);
    sec->Unlock(p1,n1,p2,0);
    }
  continue;
  }
}

return 0;
}
//---------------------------------------------------------------------------
bool C_DIRECTSOUND::Init(void)
{
if(wastry)
  if( !Uninit() )
    return false;

//++Sound Out Initialization

// CoInitialize
HRESULT res=CoInitialize(NULL);
if( !((res==S_OK)||(res==S_FALSE)) )
  return false;

//  CoInitialize     CoInitialize
wastry=true;

//++DirectSoundCreate
if(S_OK != CoCreateInstance( CLSID_DirectSound, NULL,
        CLSCTX_INPROC_SERVER,
        IID_IDirectSound,
        (VOID**)&pds ))
return false;


res=pds->Initialize(NULL);
if(S_OK!=res)
  {
  DS_ERR(res);
	return false;
  }

//++SetCooperativeLevel
res=pds->SetCooperativeLevel( GetDesktopWindow() ,DSSCL_EXCLUSIVE);
if(DS_OK!=res)
  {
  DS_ERR(res);
	return false;
  }

//++Create SoundBuffer Primary
  {
  DSBUFFERDESC desc;
  ZeroMemory(&desc, sizeof(desc));
  desc.dwSize = sizeof(DSBUFFERDESC);
  desc.dwFlags = DSBCAPS_PRIMARYBUFFER;
  if(DS_OK!=(res=pds->CreateSoundBuffer(&desc, &prim, NULL)) )
    {
    DS_ERR(res);
	  return false;
    }
  }

//++Set Format Primary
  {
  WAVEFORMATEX wfo,wf2;

  ZeroMemory(&wfo,sizeof(wfo));
  ZeroMemory(&wf2,sizeof(wf2));

  wfo.wFormatTag=WAVE_FORMAT_PCM;
  wfo.nChannels=2;
  wfo.nBlockAlign = 4;
  wfo.wBitsPerSample = 16;
  wfo.cbSize=0;
  wfo.nSamplesPerSec  = samplepersec;
  wfo.nAvgBytesPerSec = samplepersec*wfo.nBlockAlign;

  if(DS_OK!=(res=prim->SetFormat(&wfo)) )
    {
    DS_ERR(res);
	  return false;
    }
  if(DS_OK!=(res=prim->GetFormat(&wf2,sizeof(wf2),NULL)) )
    {
    DS_ERR(res);
	  return false;
    }
  for(int i=0;i<sizeof(WAVEFORMATEX)/sizeof(WORD);i++)
  if(((WORD*)&wfo)[i]!=((WORD*)&wf2)[i])
	  return false;
  }

//++Create SoundBuffer Secondary
  {
  WAVEFORMATEX wfo;
  wfo.wFormatTag=WAVE_FORMAT_PCM;
  wfo.nChannels=2;
  wfo.nBlockAlign = 4;
  wfo.wBitsPerSample = 16;
  wfo.cbSize=0;
  wfo.nSamplesPerSec  = samplepersec;
  wfo.nAvgBytesPerSec = samplepersec*wfo.nBlockAlign;


  szinbufer=valuecount*wfo.nBlockAlign;
  
  DSBUFFERDESC desc;
  ZeroMemory( &desc, sizeof(desc) );
  desc.dwSize = sizeof(DSBUFFERDESC);
  desc.dwFlags =DSBCAPS_GETCURRENTPOSITION2|DSBCAPS_GLOBALFOCUS|DSBCAPS_CTRLPOSITIONNOTIFY;
  desc.dwBufferBytes = szinbufer;
  desc.lpwfxFormat =&wfo;

  if(DS_OK!=(res=pds->CreateSoundBuffer(&desc, &sec, NULL)) )
    {
    DS_ERR(res);
	  return false;
    }
  }

//++Initialization Notifications Hendling

//++CreateEvent
    {
    evento[0]=CreateEvent(NULL,FALSE,FALSE,NULL);
    evento[1]=CreateEvent(NULL,FALSE,FALSE,NULL);
    if( (NULL==evento[0])||(NULL==evento[1]) )
      return false;
    }


//++Query Notify Secondary Out
LPDIRECTSOUNDNOTIFY  pdsn;
if(DS_OK!=(res=sec->QueryInterface(IID_IDirectSoundNotify,(LPVOID*)&pdsn)) )
  {
  DS_ERR(res);
	return false;
  }


//++Set Notification Positions Out
  {
  DSBPOSITIONNOTIFY PositionNotify[2];
  PositionNotify[0].dwOffset = 0;
  PositionNotify[0].hEventNotify = evento[0];
  PositionNotify[1].dwOffset = szinbufer/2;
  PositionNotify[1].hEventNotify = evento[1];
  if(DS_OK!=(res=pdsn->SetNotificationPositions(2, PositionNotify)) )
    {
    pdsn->Release();
    DS_ERR(res);
	  return false;
    }
  }
pdsn->Release();


//++Create Thread
run=true;
  {
  DWORD ID;
  // THREAD_PRIORITY_ABOVE_NORMAL THREAD_PRIORITY_IDLE
  hthread=CreateThread(NULL,0,ThreadFunc,this,THREAD_PRIORITY_ABOVE_NORMAL,&ID);
  if(NULL==hthread)
    return false;

  //HANDLE hprocess=GetCurrentProcess();
  //SetPriorityClass(hprocess,REALTIME_PRIORITY_CLASS);
  }

initok=true;

if( !Runing(true) )
  {
  initok=false;
  return false;
  }

return true;
}

//---------------------------------------------------------------------------
bool C_DIRECTSOUND::Uninit(void)
{
if(!wastry)
  return false;

run=false;
SetEvent(evento[0]);
SetEvent(evento[1]);

if(hthread!=NULL)
    {
    if(WAIT_OBJECT_0!=WaitForSingleObject(hthread,1000))
      return false;
    }

CloseHandle(hthread);

CloseHandle(evento[0]);
CloseHandle(evento[1]);

if(prim!=NULL)
  prim->Release();
if(sec!=NULL)
  sec->Release();
if(pds!=NULL)
  pds->Release();

CoUninitialize();//    CoInitialize

Clear();

return true;
}
//---------------------------------------------------------------------------
bool C_DIRECTSOUND::Runing(bool runing)
{
if(!initok)
  return false;
  
if(runing)
  {
  if( interogate )
    return false;

  if( DS_OK!=sec->Play(0,0,DSBPLAY_LOOPING) )
    return false;

  interogate=true;
  }
else
  {
  if( !interogate )
    return false;

  if( DS_OK!=sec->Stop() )
    return false;

  interogate=false;
  }


return true;
}
//---------------------------------------------------------------------------
void    C_DIRECTSOUND::Interogate16s(void *bufer,unsigned szbufer)
{

szbufer/=4;

double dt= (2*M_PI*fric)/samplepersec;
static double t=0;
unsigned n=0;

for(;n<szbufer;n++,t+=dt)
  {
  ((__int16*)bufer)[n*2]=(double(amp-1)*sin(t));
  ((__int16*)bufer)[n*2+1]=(double(amp-1)*sin(t));
  }

}
//---------------------------------------------------------------------------
bool C_DIRECTSOUND::Fric(double _fric)
{
fric=_fric;
return true;
}
//---------------------------------------------------------------------------
bool C_DIRECTSOUND::Amp(double _fric)
{
// CalcAmp
//amp=_fric*2.5/ 
return true;
}
//---------------------------------------------------------------------------

